From 9ca0e82455297040069b8274649e7ddd28a5d65b Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?John=20H=C3=B6gberg?= <john@erlang.org>
Date: Wed, 10 Jul 2019 15:41:13 +0200
Subject: [PATCH 71/73] compiler: Fix compiler crash introduced by OTP-15952

An assertion in code generation would fail when the common exit
block was ?BADARG_BLOCK, as some operations expect to always "fail"
directly to that block (= throw an exception) and we had inserted
a dummy block in between.

Other operations could also get funny fail labels, jumping to
blocks that immediately jumped to {f,0}, but these were all cleaned
up by beam_jump, sweeping the bug under the rug.
---
 lib/compiler/src/beam_ssa_pre_codegen.erl |  6 +++++-
 lib/compiler/test/beam_ssa_SUITE.erl      | 15 +++++++++++++++
 2 files changed, 20 insertions(+), 1 deletion(-)

diff --git a/lib/compiler/src/beam_ssa_pre_codegen.erl b/lib/compiler/src/beam_ssa_pre_codegen.erl
index a2e687930bb..7ef604d4447 100644
--- a/lib/compiler/src/beam_ssa_pre_codegen.erl
+++ b/lib/compiler/src/beam_ssa_pre_codegen.erl
@@ -1472,10 +1472,14 @@ find_loop_exit([L1,L2|_Ls], Blocks) ->
     find_loop_exit_1(Path1, cerl_sets:from_list(Path2));
 find_loop_exit(_, _) -> none.
 
+find_loop_exit_1([?BADARG_BLOCK | T], OtherPath) ->
+    %% ?BADARG_BLOCK is a marker and not an actual block, so we can't consider
+    %% it to be a common block even if both paths cross it.
+    find_loop_exit_1(T, OtherPath);
 find_loop_exit_1([H|T], OtherPath) ->
     case cerl_sets:is_element(H, OtherPath) of
         true -> H;
-        false ->  find_loop_exit_1(T, OtherPath)
+        false -> find_loop_exit_1(T, OtherPath)
     end;
 find_loop_exit_1([], _) -> none.
 
diff --git a/lib/compiler/test/beam_ssa_SUITE.erl b/lib/compiler/test/beam_ssa_SUITE.erl
index 256bb955596..dd1b7ddcd3b 100644
--- a/lib/compiler/test/beam_ssa_SUITE.erl
+++ b/lib/compiler/test/beam_ssa_SUITE.erl
@@ -196,6 +196,9 @@ recv(_Config) ->
     self() ! 2,
     b = tricky_recv_5(),
 
+    %% tricky_recv_6/0 is a compile-time error.
+    tricky_recv_6(),
+
     ok.
 
 sync_wait_mon({Pid, Ref}, Timeout) ->
@@ -321,6 +324,18 @@ tricky_recv_5() ->
         _:_ -> c
     end.
 
+%% When fixing tricky_recv_5, we introduced a compiler crash when the common
+%% exit block was ?BADARG_BLOCK and floats were in the picture.
+tricky_recv_6() ->
+    RefA = make_ref(),
+    RefB = make_ref(),
+    receive
+        {RefA, Number} -> Number + 1.0;
+        {RefB, Number} -> Number + 2.0
+    after 0 ->
+        ok
+    end.
+
 maps(_Config) ->
     {'EXIT',{{badmatch,#{}},_}} = (catch maps_1(any)),
     ok.

